diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/idp.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/idp.c
--- linux-3.0/arch/arm/mach-pxa/idp.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/idp.c	2011-10-18 04:06:23.000000000 +0000
@@ -196,6 +196,7 @@ MACHINE_START(PXA_IDP, "Vibren PXA255 ID
 	/* Maintainer: Vibren Technologies */
 	.map_io		= idp_map_io,
 	.init_irq	= pxa25x_init_irq,
+	.handle_irq	= pxa25x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= idp_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/corgi.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/corgi.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/corgi.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/corgi.h	2011-10-18 04:06:23.000000000 +0000
@@ -34,7 +34,7 @@
 #define CORGI_GPIO_LCDCON_CS		(19) /* LCD Control Chip Select */
 #define CORGI_GPIO_MAX1111_CS		(20) /* MAX1111 Chip Select */
 #define CORGI_GPIO_ADC_TEMP_ON		(21) /* Select battery voltage or temperature */
-#define CORGI_GPIO_IR_ON			(22) /* Enable IR Transciever */
+#define CORGI_GPIO_IR_ON			(22) /* Enable IR Transceiver */
 #define CORGI_GPIO_ADS7846_CS		(24) /* ADS7846 Chip Select */
 #define CORGI_GPIO_SD_PWR			(33) /* MMC/SD Power */
 #define CORGI_GPIO_CHRG_ON			(38) /* Enable battery Charging */
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/hardware.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/hardware.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/hardware.h	2011-04-03 18:50:03.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/hardware.h	2011-10-18 04:06:23.000000000 +0000
@@ -337,9 +337,6 @@ extern unsigned long get_clock_tick_rate
 #endif
 
 #if defined(CONFIG_MACH_ARMCORE) && defined(CONFIG_PCI)
-#define PCIBIOS_MIN_IO		0
-#define PCIBIOS_MIN_MEM		0
-#define pcibios_assign_all_busses()	1
 #define ARCH_HAS_DMA_SET_COHERENT_MASK
 #endif
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/irqs.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/irqs.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/irqs.h	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/irqs.h	2011-10-18 04:06:23.000000000 +0000
@@ -104,4 +104,16 @@
 
 #define NR_IRQS			(IRQ_BOARD_START)
 
+#ifndef __ASSEMBLY__
+struct irq_data;
+struct pt_regs;
+
+void pxa_mask_irq(struct irq_data *);
+void pxa_unmask_irq(struct irq_data *);
+void icip_handle_irq(struct pt_regs *);
+void ichp_handle_irq(struct pt_regs *);
+
+void pxa_init_irq(int irq_nr, int (*set_wake)(struct irq_data *, unsigned int));
+#endif
+
 #endif /* __ASM_MACH_IRQS_H */
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/magician.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/magician.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/magician.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/magician.h	2011-10-18 04:06:23.000000000 +0000
@@ -12,6 +12,7 @@
 #ifndef _MAGICIAN_H_
 #define _MAGICIAN_H_
 
+#include <linux/gpio.h>
 #include <mach/irqs.h>
 
 /*
@@ -77,7 +78,7 @@
  * CPLD EGPIOs
  */
 
-#define MAGICIAN_EGPIO_BASE			0x80 /* GPIO_BOARD_START */
+#define MAGICIAN_EGPIO_BASE			NR_BUILTIN_GPIO
 #define MAGICIAN_EGPIO(reg,bit) \
 	(MAGICIAN_EGPIO_BASE + 8*reg + bit)
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/memory.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/memory.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/memory.h	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/memory.h	2011-10-18 04:06:23.000000000 +0000
@@ -17,8 +17,4 @@
  */
 #define PLAT_PHYS_OFFSET	UL(0xa0000000)
 
-#if defined(CONFIG_MACH_ARMCORE) && defined(CONFIG_PCI)
-#define ARM_DMA_ZONE_SIZE	SZ_64M
-#endif
-
 #endif
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/pm.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pm.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/pm.h	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pm.h	2011-10-18 04:06:23.000000000 +0000
@@ -22,8 +22,8 @@ struct pxa_cpu_pm_fns {
 extern struct pxa_cpu_pm_fns *pxa_cpu_pm_fns;
 
 /* sleep.S */
-extern void pxa25x_cpu_suspend(unsigned int, long);
-extern void pxa27x_cpu_suspend(unsigned int, long);
+extern int pxa25x_finish_suspend(unsigned long);
+extern int pxa27x_finish_suspend(unsigned long);
 
 extern int pxa_pm_enter(suspend_state_t state);
 extern int pxa_pm_prepare(void);
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/pxa25x.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa25x.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/pxa25x.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa25x.h	2011-10-18 04:06:23.000000000 +0000
@@ -4,5 +4,14 @@
 #include <mach/hardware.h>
 #include <mach/pxa2xx-regs.h>
 #include <mach/mfp-pxa25x.h>
+#include <mach/irqs.h>
+
+extern void __init pxa25x_map_io(void);
+extern void __init pxa25x_init_irq(void);
+#ifdef CONFIG_CPU_PXA26x
+extern void __init pxa26x_init_irq(void);
+#endif
+
+#define pxa25x_handle_irq	icip_handle_irq
 
 #endif /* __MACH_PXA25x_H */
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/pxa27x-udc.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa27x-udc.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/pxa27x-udc.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa27x-udc.h	2011-10-18 04:06:23.000000000 +0000
@@ -56,9 +56,9 @@
 #define UDCFNR          __REG(0x40600014) /* UDC Frame Number Register */
 #define UDCOTGICR	__REG(0x40600018) /* UDC On-The-Go interrupt control */
 #define UDCOTGICR_IESF	(1 << 24)	/* OTG SET_FEATURE command recvd */
-#define UDCOTGICR_IEXR	(1 << 17)	/* Extra Transciever Interrupt
+#define UDCOTGICR_IEXR	(1 << 17)	/* Extra Transceiver Interrupt
 					   Rising Edge Interrupt Enable */
-#define UDCOTGICR_IEXF	(1 << 16)	/* Extra Transciever Interrupt
+#define UDCOTGICR_IEXF	(1 << 16)	/* Extra Transceiver Interrupt
 					   Falling Edge Interrupt Enable */
 #define UDCOTGICR_IEVV40R (1 << 9)	/* OTG Vbus Valid 4.0V Rising Edge
 					   Interrupt Enable */
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/pxa27x.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa27x.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/pxa27x.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa27x.h	2011-10-18 04:06:23.000000000 +0000
@@ -4,6 +4,7 @@
 #include <mach/hardware.h>
 #include <mach/pxa2xx-regs.h>
 #include <mach/mfp-pxa27x.h>
+#include <mach/irqs.h>
 
 #define ARB_CNTRL	__REG(0x48000048)  /* Arbiter Control Register */
 
@@ -17,6 +18,10 @@
 #define ARB_CORE_PARK		(1<<24)	   /* Be parked with core when idle */
 #define ARB_LOCK_FLAG		(1<<23)	   /* Only Locking masters gain access to the bus */
 
+extern void __init pxa27x_map_io(void);
+extern void __init pxa27x_init_irq(void);
 extern int __init pxa27x_set_pwrmode(unsigned int mode);
 
+#define pxa27x_handle_irq	ichp_handle_irq
+
 #endif /* __MACH_PXA27x_H */
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/pxa300.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa300.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/pxa300.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa300.h	2011-10-18 04:06:23.000000000 +0000
@@ -1,8 +1,7 @@
 #ifndef __MACH_PXA300_H
 #define __MACH_PXA300_H
 
-#include <mach/hardware.h>
-#include <mach/pxa3xx-regs.h>
+#include <mach/pxa3xx.h>
 #include <mach/mfp-pxa300.h>
 
 #endif /* __MACH_PXA300_H */
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/pxa320.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa320.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/pxa320.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa320.h	2011-10-18 04:06:23.000000000 +0000
@@ -1,8 +1,7 @@
 #ifndef __MACH_PXA320_H
 #define __MACH_PXA320_H
 
-#include <mach/hardware.h>
-#include <mach/pxa3xx-regs.h>
+#include <mach/pxa3xx.h>
 #include <mach/mfp-pxa320.h>
 
 #endif /* __MACH_PXA320_H */
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/pxa3xx.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa3xx.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/pxa3xx.h	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa3xx.h	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,14 @@
+#ifndef __MACH_PXA3XX_H	
+#define __MACH_PXA3XX_H
+
+#include <mach/hardware.h>
+#include <mach/pxa3xx-regs.h>
+#include <mach/irqs.h>
+
+extern void __init pxa3xx_map_io(void);
+extern void __init pxa3xx_init_irq(void);
+extern void __init pxa95x_init_irq(void);
+
+#define pxa3xx_handle_irq	ichp_handle_irq
+
+#endif /* __MACH_PXA3XX_H */
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/include/mach/pxa930.h torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa930.h
--- linux-3.0/arch/arm/mach-pxa/include/mach/pxa930.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/include/mach/pxa930.h	2011-10-18 04:06:23.000000000 +0000
@@ -1,8 +1,7 @@
 #ifndef __MACH_PXA930_H
 #define __MACH_PXA930_H
 
-#include <mach/hardware.h>
-#include <mach/pxa3xx-regs.h>
+#include <mach/pxa3xx.h>
 #include <mach/mfp-pxa930.h>
 
 #endif /* __MACH_PXA930_H */
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/irq.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/irq.c
--- linux-3.0/arch/arm/mach-pxa/irq.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/irq.c	2011-10-18 04:06:23.000000000 +0000
@@ -37,6 +37,8 @@
 #define IPR(i)			(((i) < 32) ? (0x01c + ((i) << 2)) :		\
 				((i) < 64) ? (0x0b0 + (((i) - 32) << 2)) :	\
 				      (0x144 + (((i) - 64) << 2)))
+#define ICHP_VAL_IRQ		(1 << 31)
+#define ICHP_IRQ(i)		(((i) >> 16) & 0x7fff)
 #define IPR_VALID		(1 << 31)
 #define IRQ_BIT(n)		(((n) - PXA_IRQ(0)) & 0x1f)
 
@@ -64,7 +66,7 @@ static inline void __iomem *irq_base(int
 	return (void __iomem *)io_p2v(phys_base[i]);
 }
 
-static void pxa_mask_irq(struct irq_data *d)
+void pxa_mask_irq(struct irq_data *d)
 {
 	void __iomem *base = irq_data_get_irq_chip_data(d);
 	uint32_t icmr = __raw_readl(base + ICMR);
@@ -73,7 +75,7 @@ static void pxa_mask_irq(struct irq_data
 	__raw_writel(icmr, base + ICMR);
 }
 
-static void pxa_unmask_irq(struct irq_data *d)
+void pxa_unmask_irq(struct irq_data *d)
 {
 	void __iomem *base = irq_data_get_irq_chip_data(d);
 	uint32_t icmr = __raw_readl(base + ICMR);
@@ -127,6 +129,36 @@ static struct irq_chip pxa_low_gpio_chip
 	.irq_set_type	= pxa_set_low_gpio_type,
 };
 
+asmlinkage void __exception_irq_entry icip_handle_irq(struct pt_regs *regs)
+{
+	uint32_t icip, icmr, mask;
+
+	do {
+		icip = __raw_readl(IRQ_BASE + ICIP);
+		icmr = __raw_readl(IRQ_BASE + ICMR);
+		mask = icip & icmr;
+
+		if (mask == 0)
+			break;
+
+		handle_IRQ(PXA_IRQ(fls(mask) - 1), regs);
+	} while (1);
+}
+
+asmlinkage void __exception_irq_entry ichp_handle_irq(struct pt_regs *regs)
+{
+	uint32_t ichp;
+
+	do {
+		__asm__ __volatile__("mrc p6, 0, %0, c5, c0, 0\n": "=r"(ichp));
+
+		if ((ichp & ICHP_VAL_IRQ) == 0)
+			break;
+
+		handle_IRQ(PXA_IRQ(ICHP_IRQ(ichp)), regs);
+	} while (1);
+}
+
 static void __init pxa_init_low_gpio_irq(set_wake_t fn)
 {
 	int irq;
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/littleton.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/littleton.c
--- linux-3.0/arch/arm/mach-pxa/littleton.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/littleton.c	2011-10-18 04:06:23.000000000 +0000
@@ -441,6 +441,7 @@ MACHINE_START(LITTLETON, "Marvell Form F
 	.map_io		= pxa3xx_map_io,
 	.nr_irqs	= LITTLETON_NR_IRQS,
 	.init_irq	= pxa3xx_init_irq,
+	.handle_irq	= pxa3xx_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= littleton_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/lpd270.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/lpd270.c
--- linux-3.0/arch/arm/mach-pxa/lpd270.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/lpd270.c	2011-10-18 04:06:23.000000000 +0000
@@ -503,6 +503,7 @@ MACHINE_START(LOGICPD_PXA270, "LogicPD P
 	.map_io		= lpd270_map_io,
 	.nr_irqs	= LPD270_NR_IRQS,
 	.init_irq	= lpd270_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= lpd270_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/lubbock.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/lubbock.c
--- linux-3.0/arch/arm/mach-pxa/lubbock.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/lubbock.c	2011-10-18 04:06:23.000000000 +0000
@@ -553,6 +553,7 @@ MACHINE_START(LUBBOCK, "Intel DBPXA250 D
 	.map_io		= lubbock_map_io,
 	.nr_irqs	= LUBBOCK_NR_IRQS,
 	.init_irq	= lubbock_init_irq,
+	.handle_irq	= pxa25x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= lubbock_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/magician.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/magician.c
--- linux-3.0/arch/arm/mach-pxa/magician.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/magician.c	2011-10-18 04:06:23.000000000 +0000
@@ -344,22 +344,14 @@ static struct pxafb_mach_info samsung_in
  * Backlight
  */
 
+static struct gpio magician_bl_gpios[] = {
+	{ EGPIO_MAGICIAN_BL_POWER,  GPIOF_DIR_OUT, "Backlight power" },
+	{ EGPIO_MAGICIAN_BL_POWER2, GPIOF_DIR_OUT, "Backlight power 2" },
+};
+
 static int magician_backlight_init(struct device *dev)
 {
-	int ret;
-
-	ret = gpio_request(EGPIO_MAGICIAN_BL_POWER, "BL_POWER");
-	if (ret)
-		goto err;
-	ret = gpio_request(EGPIO_MAGICIAN_BL_POWER2, "BL_POWER2");
-	if (ret)
-		goto err2;
-	return 0;
-
-err2:
-	gpio_free(EGPIO_MAGICIAN_BL_POWER);
-err:
-	return ret;
+	return gpio_request_array(ARRAY_AND_SIZE(magician_bl_gpios));
 }
 
 static int magician_backlight_notify(struct device *dev, int brightness)
@@ -376,8 +368,7 @@ static int magician_backlight_notify(str
 
 static void magician_backlight_exit(struct device *dev)
 {
-	gpio_free(EGPIO_MAGICIAN_BL_POWER);
-	gpio_free(EGPIO_MAGICIAN_BL_POWER2);
+	gpio_free_array(ARRAY_AND_SIZE(magician_bl_gpios));
 }
 
 static struct platform_pwm_backlight_data backlight_data = {
@@ -712,16 +703,25 @@ static struct platform_device *devices[]
 	&leds_gpio,
 };
 
+static struct gpio magician_global_gpios[] = {
+	{ GPIO13_MAGICIAN_CPLD_IRQ,   GPIOF_IN, "CPLD_IRQ" },
+	{ GPIO107_MAGICIAN_DS1WM_IRQ, GPIOF_IN, "DS1WM_IRQ" },
+	{ GPIO104_MAGICIAN_LCD_POWER_1, GPIOF_OUT_INIT_LOW, "LCD power 1" },
+	{ GPIO105_MAGICIAN_LCD_POWER_2, GPIOF_OUT_INIT_LOW, "LCD power 2" },
+	{ GPIO106_MAGICIAN_LCD_POWER_3, GPIOF_OUT_INIT_LOW, "LCD power 3" },
+	{ GPIO83_MAGICIAN_nIR_EN, GPIOF_OUT_INIT_HIGH, "nIR_EN" },
+};
+
 static void __init magician_init(void)
 {
 	void __iomem *cpld;
 	int lcd_select;
 	int err;
 
-	gpio_request(GPIO13_MAGICIAN_CPLD_IRQ, "CPLD_IRQ");
-	gpio_request(GPIO107_MAGICIAN_DS1WM_IRQ, "DS1WM_IRQ");
-
 	pxa2xx_mfp_config(ARRAY_AND_SIZE(magician_pin_config));
+	err = gpio_request_array(ARRAY_AND_SIZE(magician_global_gpios));
+	if (err)
+		pr_err("magician: Failed to request GPIOs: %d\n", err);
 
 	pxa_set_ffuart_info(NULL);
 	pxa_set_btuart_info(NULL);
@@ -729,11 +729,7 @@ static void __init magician_init(void)
 
 	platform_add_devices(ARRAY_AND_SIZE(devices));
 
-	err = gpio_request(GPIO83_MAGICIAN_nIR_EN, "nIR_EN");
-	if (!err) {
-		gpio_direction_output(GPIO83_MAGICIAN_nIR_EN, 1);
-		pxa_set_ficp_info(&magician_ficp_info);
-	}
+	pxa_set_ficp_info(&magician_ficp_info);
 	pxa27x_set_i2c_power_info(NULL);
 	pxa_set_i2c_info(&i2c_info);
 	pxa_set_mci_info(&magician_mci_info);
@@ -747,16 +743,9 @@ static void __init magician_init(void)
 		system_rev = board_id & 0x7;
 		lcd_select = board_id & 0x8;
 		pr_info("LCD type: %s\n", lcd_select ? "Samsung" : "Toppoly");
-		if (lcd_select && (system_rev < 3)) {
-			gpio_request(GPIO75_MAGICIAN_SAMSUNG_POWER, "SAMSUNG_POWER");
-			gpio_direction_output(GPIO75_MAGICIAN_SAMSUNG_POWER, 0);
-		}
-		gpio_request(GPIO104_MAGICIAN_LCD_POWER_1, "LCD_POWER_1");
-		gpio_request(GPIO105_MAGICIAN_LCD_POWER_2, "LCD_POWER_2");
-		gpio_request(GPIO106_MAGICIAN_LCD_POWER_3, "LCD_POWER_3");
-		gpio_direction_output(GPIO104_MAGICIAN_LCD_POWER_1, 0);
-		gpio_direction_output(GPIO105_MAGICIAN_LCD_POWER_2, 0);
-		gpio_direction_output(GPIO106_MAGICIAN_LCD_POWER_3, 0);
+		if (lcd_select && (system_rev < 3))
+			gpio_request_one(GPIO75_MAGICIAN_SAMSUNG_POWER,
+			                 GPIOF_OUT_INIT_LOW, "SAMSUNG_POWER");
 		pxa_set_fb_info(NULL, lcd_select ? &samsung_info : &toppoly_info);
 	} else
 		pr_err("LCD detection: CPLD mapping failed\n");
@@ -768,6 +757,7 @@ MACHINE_START(MAGICIAN, "HTC Magician")
 	.map_io = pxa27x_map_io,
 	.nr_irqs = MAGICIAN_NR_IRQS,
 	.init_irq = pxa27x_init_irq,
+	.handle_irq = pxa27x_handle_irq,
 	.init_machine = magician_init,
 	.timer = &pxa_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/mainstone.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/mainstone.c
--- linux-3.0/arch/arm/mach-pxa/mainstone.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/mainstone.c	2011-10-18 04:06:23.000000000 +0000
@@ -620,6 +620,7 @@ MACHINE_START(MAINSTONE, "Intel HCDDBBVA
 	.map_io		= mainstone_map_io,
 	.nr_irqs	= MAINSTONE_NR_IRQS,
 	.init_irq	= mainstone_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= mainstone_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/mioa701.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/mioa701.c
--- linux-3.0/arch/arm/mach-pxa/mioa701.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/mioa701.c	2011-10-18 04:06:23.000000000 +0000
@@ -177,50 +177,6 @@ static unsigned long mioa701_pin_config[
 	MFP_CFG_OUT(GPIO116, AF0, DRIVE_HIGH),
 };
 
-#define MIO_GPIO_IN(num, _desc) \
-	{ .gpio = (num), .dir = 0, .desc = (_desc) }
-#define MIO_GPIO_OUT(num, _init, _desc) \
-	{ .gpio = (num), .dir = 1, .init = (_init), .desc = (_desc) }
-struct gpio_ress {
-	unsigned gpio : 8;
-	unsigned dir : 1;
-	unsigned init : 1;
-	char *desc;
-};
-
-static int mio_gpio_request(struct gpio_ress *gpios, int size)
-{
-	int i, rc = 0;
-	int gpio;
-	int dir;
-
-	for (i = 0; (!rc) && (i < size); i++) {
-		gpio = gpios[i].gpio;
-		dir = gpios[i].dir;
-		rc = gpio_request(gpio, gpios[i].desc);
-		if (rc) {
-			printk(KERN_ERR "Error requesting GPIO %d(%s) : %d\n",
-			       gpio, gpios[i].desc, rc);
-			continue;
-		}
-		if (dir)
-			gpio_direction_output(gpio, gpios[i].init);
-		else
-			gpio_direction_input(gpio);
-	}
-	while ((rc) && (--i >= 0))
-		gpio_free(gpios[i].gpio);
-	return rc;
-}
-
-static void mio_gpio_free(struct gpio_ress *gpios, int size)
-{
-	int i;
-
-	for (i = 0; i < size; i++)
-		gpio_free(gpios[i].gpio);
-}
-
 /* LCD Screen and Backlight */
 static struct platform_pwm_backlight_data mioa701_backlight_data = {
 	.pwm_id		= 0,
@@ -346,16 +302,16 @@ irqreturn_t gsm_on_irq(int irq, void *p)
 	return IRQ_HANDLED;
 }
 
-struct gpio_ress gsm_gpios[] = {
-	MIO_GPIO_IN(GPIO25_GSM_MOD_ON_STATE, "GSM state"),
-	MIO_GPIO_IN(GPIO113_GSM_EVENT, "GSM event"),
+static struct gpio gsm_gpios[] = {
+	{ GPIO25_GSM_MOD_ON_STATE, GPIOF_IN, "GSM state" },
+	{ GPIO113_GSM_EVENT, GPIOF_IN, "GSM event" },
 };
 
 static int __init gsm_init(void)
 {
 	int rc;
 
-	rc = mio_gpio_request(ARRAY_AND_SIZE(gsm_gpios));
+	rc = gpio_request_array(ARRAY_AND_SIZE(gsm_gpios));
 	if (rc)
 		goto err_gpio;
 	rc = request_irq(gpio_to_irq(GPIO25_GSM_MOD_ON_STATE), gsm_on_irq,
@@ -369,7 +325,7 @@ static int __init gsm_init(void)
 
 err_irq:
 	printk(KERN_ERR "Mioa701: Can't request GSM_ON irq\n");
-	mio_gpio_free(ARRAY_AND_SIZE(gsm_gpios));
+	gpio_free_array(ARRAY_AND_SIZE(gsm_gpios));
 err_gpio:
 	printk(KERN_ERR "Mioa701: gsm not available\n");
 	return rc;
@@ -378,7 +334,7 @@ err_gpio:
 static void gsm_exit(void)
 {
 	free_irq(gpio_to_irq(GPIO25_GSM_MOD_ON_STATE), NULL);
-	mio_gpio_free(ARRAY_AND_SIZE(gsm_gpios));
+	gpio_free_array(ARRAY_AND_SIZE(gsm_gpios));
 }
 
 /*
@@ -749,14 +705,16 @@ static void mioa701_restart(char c, cons
 	arm_machine_restart('s', cmd);
 }
 
-static struct gpio_ress global_gpios[] = {
-	MIO_GPIO_OUT(GPIO9_CHARGE_EN, 1, "Charger enable"),
-	MIO_GPIO_OUT(GPIO18_POWEROFF, 0, "Power Off"),
-	MIO_GPIO_OUT(GPIO87_LCD_POWER, 0, "LCD Power"),
+static struct gpio global_gpios[] = {
+	{ GPIO9_CHARGE_EN, GPIOF_OUT_INIT_HIGH, "Charger enable" },
+	{ GPIO18_POWEROFF, GPIOF_OUT_INIT_LOW, "Power Off" },
+	{ GPIO87_LCD_POWER, GPIOF_OUT_INIT_LOW, "LCD Power" },
 };
 
 static void __init mioa701_machine_init(void)
 {
+	int rc;
+
 	PSLR  = 0xff100000; /* SYSDEL=125ms, PWRDEL=125ms, PSLR_SL_ROD=1 */
 	PCFR = PCFR_DC_EN | PCFR_GPR_EN | PCFR_OPDE;
 	RTTR = 32768 - 1; /* Reset crazy WinCE value */
@@ -766,7 +724,9 @@ static void __init mioa701_machine_init(
 	pxa_set_ffuart_info(NULL);
 	pxa_set_btuart_info(NULL);
 	pxa_set_stuart_info(NULL);
-	mio_gpio_request(ARRAY_AND_SIZE(global_gpios));
+	rc = gpio_request_array(ARRAY_AND_SIZE(global_gpios));
+	if (rc)
+		pr_err("MioA701: Failed to request GPIOs: %d", rc);
 	bootstrap_init();
 	pxa_set_fb_info(NULL, &mioa701_pxafb_info);
 	pxa_set_mci_info(&mioa701_mci_info);
@@ -794,6 +754,7 @@ MACHINE_START(MIOA701, "MIO A701")
 	.boot_params	= 0xa0000100,
 	.map_io		= &pxa27x_map_io,
 	.init_irq	= &pxa27x_init_irq,
+	.handle_irq	= &pxa27x_handle_irq,
 	.init_machine	= mioa701_machine_init,
 	.timer		= &pxa_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/mp900.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/mp900.c
--- linux-3.0/arch/arm/mach-pxa/mp900.c	2011-04-03 18:50:03.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/mp900.c	2011-10-18 04:06:23.000000000 +0000
@@ -96,6 +96,7 @@ MACHINE_START(NEC_MP900, "MobilePro900/C
 	.timer		= &pxa_timer,
 	.map_io		= pxa25x_map_io,
 	.init_irq	= pxa25x_init_irq,
+	.handle_irq	= pxa25x_handle_irq,
 	.init_machine	= mp900c_init,
 MACHINE_END
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/palmld.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmld.c
--- linux-3.0/arch/arm/mach-pxa/palmld.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmld.c	2011-10-18 04:06:23.000000000 +0000
@@ -345,6 +345,7 @@ MACHINE_START(PALMLD, "Palm LifeDrive")
 	.boot_params	= 0xa0000100,
 	.map_io		= palmld_map_io,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= palmld_init
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/palmt5.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmt5.c
--- linux-3.0/arch/arm/mach-pxa/palmt5.c	2011-04-03 18:50:03.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmt5.c	2011-10-18 04:06:23.000000000 +0000
@@ -206,6 +206,7 @@ MACHINE_START(PALMT5, "Palm Tungsten|T5"
 	.map_io		= pxa27x_map_io,
 	.reserve	= palmt5_reserve,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= palmt5_init
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/palmtc.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmtc.c
--- linux-3.0/arch/arm/mach-pxa/palmtc.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmtc.c	2011-10-18 04:06:23.000000000 +0000
@@ -31,14 +31,13 @@
 #include <asm/mach/arch.h>
 #include <asm/mach/map.h>
 
+#include <mach/pxa25x.h>
 #include <mach/audio.h>
 #include <mach/palmtc.h>
 #include <mach/mmc.h>
 #include <mach/pxafb.h>
-#include <mach/mfp-pxa25x.h>
 #include <mach/irda.h>
 #include <mach/udc.h>
-#include <mach/pxa2xx-regs.h>
 
 #include "generic.h"
 #include "devices.h"
@@ -541,6 +540,7 @@ MACHINE_START(PALMTC, "Palm Tungsten|C")
 	.boot_params 	= 0xa0000100,
 	.map_io		= pxa25x_map_io,
 	.init_irq	= pxa25x_init_irq,
+	.handle_irq	= pxa25x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= palmtc_init
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/palmte2.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmte2.c
--- linux-3.0/arch/arm/mach-pxa/palmte2.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmte2.c	2011-10-18 04:06:23.000000000 +0000
@@ -31,11 +31,11 @@
 #include <asm/mach/arch.h>
 #include <asm/mach/map.h>
 
+#include <mach/pxa25x.h>
 #include <mach/audio.h>
 #include <mach/palmte2.h>
 #include <mach/mmc.h>
 #include <mach/pxafb.h>
-#include <mach/mfp-pxa25x.h>
 #include <mach/irda.h>
 #include <mach/udc.h>
 #include <mach/palmasoc.h>
@@ -359,6 +359,7 @@ MACHINE_START(PALMTE2, "Palm Tungsten|E2
 	.boot_params	= 0xa0000100,
 	.map_io		= pxa25x_map_io,
 	.init_irq	= pxa25x_init_irq,
+	.handle_irq	= pxa25x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= palmte2_init
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/palmtreo.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmtreo.c
--- linux-3.0/arch/arm/mach-pxa/palmtreo.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmtreo.c	2011-10-18 04:06:23.000000000 +0000
@@ -444,6 +444,7 @@ MACHINE_START(TREO680, "Palm Treo 680")
 	.map_io         = pxa27x_map_io,
 	.reserve	= treo_reserve,
 	.init_irq       = pxa27x_init_irq,
+	.handle_irq       = pxa27x_handle_irq,
 	.timer          = &pxa_timer,
 	.init_machine   = treo680_init,
 MACHINE_END
@@ -453,6 +454,7 @@ MACHINE_START(CENTRO, "Palm Centro 685")
 	.map_io         = pxa27x_map_io,
 	.reserve	= treo_reserve,
 	.init_irq       = pxa27x_init_irq,
+	.handle_irq       = pxa27x_handle_irq,
 	.timer          = &pxa_timer,
 	.init_machine	= centro_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/palmtx.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmtx.c
--- linux-3.0/arch/arm/mach-pxa/palmtx.c	2011-04-03 18:50:03.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmtx.c	2011-10-18 04:06:23.000000000 +0000
@@ -367,6 +367,7 @@ MACHINE_START(PALMTX, "Palm T|X")
 	.boot_params	= 0xa0000100,
 	.map_io		= palmtx_map_io,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= palmtx_init
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/palmz72.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmz72.c
--- linux-3.0/arch/arm/mach-pxa/palmz72.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/palmz72.c	2011-10-18 04:06:23.000000000 +0000
@@ -33,6 +33,7 @@
 #include <linux/i2c-gpio.h>
 
 #include <asm/mach-types.h>
+#include <asm/suspend.h>
 #include <asm/mach/arch.h>
 #include <asm/mach/map.h>
 
@@ -401,6 +402,7 @@ MACHINE_START(PALMZ72, "Palm Zire72")
 	.boot_params	= 0xa0000100,
 	.map_io		= pxa27x_map_io,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= palmz72_init
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/pcm027.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pcm027.c
--- linux-3.0/arch/arm/mach-pxa/pcm027.c	2011-04-03 18:50:03.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pcm027.c	2011-10-18 04:06:23.000000000 +0000
@@ -262,6 +262,7 @@ MACHINE_START(PCM027, "Phytec Messtechni
 	.map_io		= pcm027_map_io,
 	.nr_irqs	= PCM027_NR_IRQS,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= pcm027_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/pm.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pm.c
--- linux-3.0/arch/arm/mach-pxa/pm.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pm.c	2011-10-18 04:06:23.000000000 +0000
@@ -42,7 +42,6 @@ int pxa_pm_enter(suspend_state_t state)
 
 	/* *** go zzz *** */
 	pxa_cpu_pm_fns->enter(state);
-	cpu_init();
 
 	if (state != PM_SUSPEND_STANDBY && pxa_cpu_pm_fns->restore) {
 		/* after sleeping, validate the checksum */
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/poodle.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/poodle.c
--- linux-3.0/arch/arm/mach-pxa/poodle.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/poodle.c	2011-10-18 04:06:23.000000000 +0000
@@ -468,6 +468,7 @@ MACHINE_START(POODLE, "SHARP Poodle")
 	.map_io		= pxa25x_map_io,
 	.nr_irqs	= POODLE_NR_IRQS,	/* 4 for LoCoMo */
 	.init_irq	= pxa25x_init_irq,
+	.handle_irq	= pxa25x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= poodle_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/pxa25x.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pxa25x.c
--- linux-3.0/arch/arm/mach-pxa/pxa25x.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pxa25x.c	2011-10-18 04:06:23.000000000 +0000
@@ -25,6 +25,7 @@
 #include <linux/irq.h>
 
 #include <asm/mach/map.h>
+#include <asm/suspend.h>
 #include <mach/hardware.h>
 #include <mach/irqs.h>
 #include <mach/gpio.h>
@@ -244,7 +245,7 @@ static void pxa25x_cpu_pm_enter(suspend_
 
 	switch (state) {
 	case PM_SUSPEND_MEM:
-		pxa25x_cpu_suspend(PWRMODE_SLEEP, PLAT_PHYS_OFFSET - PAGE_OFFSET);
+		cpu_suspend(PWRMODE_SLEEP, pxa25x_finish_suspend);
 		break;
 	}
 }
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/pxa27x.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pxa27x.c
--- linux-3.0/arch/arm/mach-pxa/pxa27x.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pxa27x.c	2011-10-18 04:06:23.000000000 +0000
@@ -24,6 +24,7 @@
 #include <asm/mach/map.h>
 #include <mach/hardware.h>
 #include <asm/irq.h>
+#include <asm/suspend.h>
 #include <mach/irqs.h>
 #include <mach/gpio.h>
 #include <mach/pxa27x.h>
@@ -284,6 +285,11 @@ void pxa27x_cpu_pm_restore(unsigned long
 void pxa27x_cpu_pm_enter(suspend_state_t state)
 {
 	extern void pxa_cpu_standby(void);
+#ifndef CONFIG_IWMMXT
+	u64 acc0;
+
+	asm volatile("mra %Q0, %R0, acc0" : "=r" (acc0));
+#endif
 
 	/* ensure voltage-change sequencer not initiated, which hangs */
 	PCFR &= ~PCFR_FVC;
@@ -299,7 +305,10 @@ void pxa27x_cpu_pm_enter(suspend_state_t
 		pxa_cpu_standby();
 		break;
 	case PM_SUSPEND_MEM:
-		pxa27x_cpu_suspend(pwrmode, PLAT_PHYS_OFFSET - PAGE_OFFSET);
+		cpu_suspend(pwrmode, pxa27x_finish_suspend);
+#ifndef CONFIG_IWMMXT
+		asm volatile("mar acc0, %Q0, %R0" : "=r" (acc0));
+#endif
 		break;
 	}
 }
